sk(1)

NAME
sk - fuzzy finder in rust

SYNOPSIS
sk [options]

DESCRIPTION
sk is a general-purpose command-line fuzzy finder.

OPTIONS

  Search mode

-e, --exact
    Enable exact-match

--regex
    Search with regular expression instead of fuzzy match

--algo=TYPE
    Fuzzy matching algorithm (default: skim_v2)
    skim_v2 Almost always the one to choose
    skim_v1 The legacy algorithm
    clangd the one used by clangd for keyword completion

--case=[smart,respect,ignore]
    To ignore case on matching or not. (default smart)

-n, --nth=N[,..]
    Comma-separated list of field index expressions for limiting search scope. See FIELD INDEX EXPRESSION for the details.

--with-nth=N[,..]
    Transform the presentation of each line using field index expressions

-d, --delimiter=STR
    Field delimiter regex for --nth and --with-nth (default: AWK-style)

  Search result

--tac
    Reverse the order of the search result(normally used together with --no-sort)

--no-sort
    Do not sort the search result(normally used together with --tac)
    e.g. history | sk --tac --no-sort

--tiebreak=CRI[,..]
    Comma-separated list of sort criteria to apply when the scores are tied.
    score Score of the fuzzy match algorithm
    index Prefers line that appeared earlier in the input stream
    begin Prefers line with matched substring closer to the beginning
    end Prefers line with matched substring closer to the end
    - Each criterion could be negated, e.g. (-index)
    - Each criterion should appear only once in the list

  Interface

-i, --interactive
    Start the finder in the command query

-c, --cmd [cmd]
    Specify the command to invoke for fetching options

-I replstr
    Replace replstr with the selected item

-m, --multi
    Enable multi-select with tab/shift-tab

--no-multi
    Disable multi-select

--bind=KEYBINDS
    Comma-separated list of custom key bindings. See KEY BINDINGS for the details.

--no-hscroll
    Disable horizontal scroll

--height=HEIGHT[%]
    Display sk window below the cursor with the given height instead of using the full screen.

--min-height=HEIGHT
    Minimum height when --height is given in percent (default: 10). Ignored when --height is not specified.

--layout=LAYOUT
    Choose the layout (default: default)
    default Display from the bottom of the screen
    reverse Display from the top of the screen
    reverse-list Display from the top of the screen, prompt at the bottom

--reverse
    A synonym for --layout=reverse

--margin=MARGIN
    Comma-separated expression for margins around the finder.
    TRBL Same margin for top, right, bottom, and left
    TB,RL Vertical, horizontal margin
    T,RL,B Top, horizontal, bottom margin
    T,R,B,L Top, right, bottom, left margin
    Each part can be given in absolute number or in percentage relative to the terminal size with % suffix.
    e.g. sk --margin 10%
         sk --margin 1,5%

--inline-info
    Display finder info inline with the query

-p --prompt=STR
    Input prompt (default: '> ')

--cmd-prompt=STR
    Command prompt (default: 'c> ')

--header=STR
    The given string will be printed as the sticky header. The lines are displayed in the given order from top to bottom regardless of --layout option, and are not affected by --with-nth. ANSI color codes are processed even when --ansi is not set.

--header-lines=N
    The first N lines of the input are treated as the sticky header. When --with-nth is set, the lines are transformed just like the other lines that follow.

--keep-right
    Keep the right end of the line visible when it's too long. Effective only when the query string is empty.

--skip-to-pattern
    Line will start with the start of the matched pattern. Effective only when the query string is empty. Was designed to skip showing starts of paths of rg/grep results.
    e.g. sk -i -c "rg {} --color=always" --skip-to-pattern '[^/]*:' --ansi

--no-clear-if-empty
    Do not clear previous items if new command returns empty result. This might be useful to reduce flickering when typing new commands and the half-complete commands are not valid. This is not default however because similar usecases for grep and rg had already been optimized where empty result of a query do mean "empty" and previous results should be cleared.

--show-cmd-error
    If the command fails, send the error messages and show them as items. This option was intended to help debugging interactive commands. It's not enabled by default because the command often fails before we complete the "cmd-query" and error messages would be annoying.

  Display

--ansi
    Enable processing of ANSI color codes

--tabstop=SPACES
    Number of spaces for a tab character (default: 8)

--color=[BASE_SCHEME][,COLOR:ANSI]
    Color configuration. The name of the base color scheme is followed by custom color mappings. Ansi color code of -1 denotes terminal default foreground/background color. You can also specify 24-bit color in #rrggbb format.
    e.g. sk --color=bg+:24
         sk --color=light,fg:232,bg:255,bg+:116,info:27
    BASE SCHEME:
        (default: dark on 256-color terminal, otherwise 16)
        dark Color scheme for dark 256-color terminal
        light Color scheme for light 256-color terminal
        16 Color scheme for 16-color terminal
        bw No colors COLOR:
        fg Text
        bg Background
        matched|hl Text of highlighted substrings
        matched_bg Background of highlighted substrings
        current|fg+ Text (current line)
        current_bg|bg+ Background (current line)
        current_match|hl+ Text of Highlighted substrings (current line)
        current_match_bg Background of highlighted substrings (current line)
        query Text of Query (the texts after the prompt)
        query_bg Background of Query
        info Info
        border Border of the preview window and horizontal separators (--border)
        prompt Prompt
        pointer|cursor Pointer to the current line (no effect now)
        marker|selected Multi-select marker
        spinner Streaming input indicator
        header Header

  History

--history=HISTORY_FILE
    Load search history from the specified file and update the file on completion. When enabled, CTRL-N and CTRL-P are automatically remapped to next-history and previous-history.

--history-size=N
    Maximum number of entries in the history file (default: 1000). The file is automatically truncated when the number of the lines exceeds the value.

--cmd-history=HISTORY_FILE
    Load command query history from the specified file and update the file on completion. When enabled, CTRL-N and CTRL-P are automatically remapped to next-history and previous-history.

--cmd-history-size=N
    Maximum number of command query entries in the history file (default: 1000). The file is automatically truncated when the number of the lines exceeds the value.

  Preview

--preview=COMMAND
    Execute the given command for the current line and display the result on the preview window. {} in the command is the placeholder that is replaced to the single-quoted string of the current line. To transform the replacement string, specify field index expressions between the braces (See FIELD INDEX EXPRESSION for the details).
    e.g. sk --preview='head -$LINES {}'
         ls -l | sk --preview="echo user={3} when={-4..-2}; cat {-1}" --header-lines=1 sk overrides $LINES and $COLUMNS so that they represent the exact size of the preview window. A placeholder expression starting with + flag will be replaced to the space-separated list of the selected lines (or the current line if no selection was made) individually quoted. e.g.
         sk --multi --preview='head -10 {+}'
         git log --oneline | sk --multi --preview 'git show {+1}' Note that you can escape a placeholder pattern by prepending a backslash. Also, {q} is replaced to the current query string. {cq} is replaced to the current command query string. {n} is replaced to zero-based ordinal index of the line. Use {+n} if you want all index numbers when multiple lines are selected Preview window will be updated even when there is no match for the current query if any of the placeholder expressions evaluates to a non-empty string.

--preview-window=[POSITION][:SIZE[%]][:wrap][:hidden][:+SCROLL[-OFFSET]]
    POSITION: (default: right)
        up
        down
        left
        right
Determine the layout of the preview window. If the argument ends with :hidden, the preview window will be hidden by default until toggle-preview action is triggered. Long lines are truncated by default. Line wrap can be enabled with :wrap flag. If size is given as 0, preview window will not be visible, but sk will still execute the command in the background. +SCROLL[-OFFSET] determines the initial scroll offset of the preview window. SCROLL can be either a numeric integer or a single-field index expression that refers to a numeric integer. The optional -OFFSET part is for adjusting the base offset so that you can see the text above it. It should be given as a numeric integer (-INTEGER), or as a denominator form (-/INTEGER) for specifying a fraction of the preview window height.
    e.g.
         # Non-default scroll window positions and sizes
         sk --preview="head {}" --preview-window=up:30%
         sk --preview="file {}" --preview-window=down:2
         # Initial scroll offset is set to the line number of each line of
         # git grep output *minus* 5 lines (-5)
         git grep --line-number '' |
           sk --delimiter : --preview 'nl {1}' --preview-window +{2}-5
         # Preview with bat, matching line in the middle of the window (-/2)
         git grep --line-number '' |
           sk --delimiter : \
               --preview 'bat --style=numbers --color=always --highlight-line {2} {1}' \
               --preview-window +{2}-/2

  Scripting

-q, --query=STR
    Start the finder with the given query

--cmd-query=STR
    Specify the initial query for the command query

--print-query
    Print query as the first line

-f, --filter=STR
    Filter mode. Do not start interactive finder. It's like a fuzzy-version of grep. skim will output the score and the item to stdout.

--expect=KEY[,..]
    Comma-separated list of keys that can be used to complete sk in addition to the default enter key. When this option is set, sk will print the name of the key pressed as the first line of its output (or as the second line if --print-query is also used). The line will be empty if sk is completed with the default enter key. If --expect option is specified multiple times, sk will expect the union of the keys. --no-expect will clear the list.
    e.g. sk --expect=ctrl-v,ctrl-t,alt-s --expect=f1,f2,~,@

--read0
    Read input delimited by ASCII NUL characters instead of newline characters

--print0
    Print output delimited by ASCII NUL characters instead of newline characters

--no-clear
    Do not clear finder interface on exit. If skim was started in full screen mode, it will not switch back to the original screen, so you'll have to manually run tput rmcup to return. This option can be used to avoid flickering of the screen when your application needs to start skim multiple times in order.

-1, --select-1
    Automatically select the only match

-0, --exit-0
    Exit immediately when there's no match

--sync
    Synchronous search for multi-staged filtering. If specified, skim will launch ncurses finder only after the input stream is complete.
    e.g. sk --multi | sk --sync

--pre-select-n=NUM
    Pre-select the first NUM items in the multi-selection mode.

--pre-select-pat=REGEX
    Pre-select the items that matches the REGEX specified in multi-selection mode. Check the doc for the detailed syntax: https://docs.rs/regex/1.4.1/regex/

--pre-select-items=$'item1\nitem2'
    Pre-select the specified items (separated by newline character) in multi-selection mode.

--pre-select-file=FILENAME
    Pre-select the items read from FILENAME (separated by newline character) in multi-selection mode.

--version
    Display version information and exit

ENVIRONMENT VARIABLES

SKIM_DEFAULT_COMMAND
    Default command to use when input is tty. On *nix systems, sk runs the command with sh -c, so make sure that it's POSIX-compliant.

SKIM_DEFAULT_OPTIONS
    Default options. e.g. export SKIM_DEFAULT_OPTIONS="--multi

EXIT STATUS
0 Normal exit
1 No match
2 Error
130 Interrupted with CTRL-C or ESC

FIELD INDEX EXPRESSION
A field index expression can be a non-zero integer or a range expression ([BEGIN]..[END]). --nth and --with-nth take a comma-separated list of field index expressions.

  Examples
1 The 1st field
2 The 2nd field
-1 The last field
-2 The 2nd to last field
3..5 From the 3rd field to the 5th field
2.. From the 2nd field to the last field
..-3 From the 1st field to the 3rd to the last field
.. All the fields

EXTENDED SEARCH MODE
Unless specified otherwise, sk will start in "extended-search mode". In this mode, you can specify multiple patterns delimited by spaces, such as: 'wild ^music .mp3$ sbtrkt !rmx You can prepend a backslash to a space (\ ) to match a literal space character.

  Exact-match (quoted)
A term that is prefixed by a single-quote character (') is interpreted as an "exact-match" (or "non-fuzzy") term. sk will search for the exact occurrences of the string.

  Anchored-match
A term can be prefixed by ^, or suffixed by $ to become an anchored-match term. Then sk will search for the lines that start with or end with the given string. An anchored-match term is also an exact-match term.

  Negation
If a term is prefixed by !, sk will exclude the lines that satisfy the term from the result. In this case, sk performs exact match by default.

  Exact-match by default
If you don't prefer fuzzy matching and do not wish to "quote" (prefixing with ') every word, start sk with -e or --exact option. Note that when --exact is set, '-prefix "unquotes" the term.

  OR operator
A single bar character term acts as an OR operator. For example, the following query matches entries that start with core and end with either go, rb, or py. e.g. ^core go$ | rb$ | py$

KEY BINDINGS
You can customize key bindings of sk with --bind option which takes a comma-separated list of key binding expressions. Each key binding expression follows the following format: KEY:ACTION e.g. sk --bind=ctrl-j:accept,ctrl-k:kill-line AVAILABLE KEYS: (SYNONYMS)
    ctrl-[a-z]
    ctrl-space
    ctrl-alt-[a-z]
    alt-[a-zA-Z]
    alt-[0-9]
    f[1-12]
    enter (ctrl-m)
    space
    bspace (bs)
    alt-up
    alt-down
    alt-left
    alt-right
    alt-enter (alt-ctrl-m)
    alt-space
    alt-bspace (alt-bs)
    alt-/
    tab
    btab (shift-tab)
    esc
    del
    up
    down
    left
    right
    home
    end
    pgup (page-up)
    pgdn (page-down)
    shift-up
    shift-down
    shift-left
    shift-right
    alt-shift-up
    alt-shift-down
    alt-shift-left
    alt-shift-right
    or any single character
  ACTION: DEFAULT BINDINGS (NOTES):
    abort ctrl-c ctrl-q esc
    accept enter
    append-and-select
    backward-char ctrl-b left
    backward-delete-char ctrl-h bspace
    backward-kill-word alt-bs
    backward-word alt-b shift-left
    beginning-of-line ctrl-a home
    clear-screen ctrl-l
    delete-char del
    delete-charEOF ctrl-d
    deselect-all
    down ctrl-j ctrl-n down
    end-of-line ctrl-e end
    execute(...) (see below for the details)
    execute-silent(...) (see below for the details)
    forward-char ctrl-f right
    forward-word alt-f shift-right
    if-non-matched
    if-query-empty
    if-query-not-empty
    ignore
    kill-line
    kill-word alt-d
    next-history (ctrl-n on --history or --cmd-history)
    page-down pgdn
    page-up pgup
    half-page-down
    half-page-up
    preview-up shift-up
    preview-down shift-down
    preview-left
    preview-right
    preview-page-down
    preview-page-up
    previous-history (ctrl-p on --history or --cmd-history)
    select-all
    toggle
    toggle-all
    toggle+down ctrl-i (tab)
    toggle-in (--layout=reverse* ? toggle+up : toggle+down)
    toggle-out (--layout=reverse* ? toggle+down : toggle+up)
    toggle-preview
    toggle-preview-wrap
    toggle-sort
    toggle+up btab (shift-tab)
    unix-line-discard ctrl-u
    unix-word-rubout ctrl-w
    up ctrl-k ctrl-p up
    yank ctrl-y Multiple actions can be chained using + separator.
    sk --bind 'ctrl-a:select-all+accept' With execute(...) action, you can execute arbitrary commands without leaving sk. For example, you can turn sk into a simple file browser by binding enter key to less command like follows.
    sk --bind "enter:execute(less {})" You can use the same placeholder expressions as in --preview. If the command contains parentheses, sk may fail to parse the expression. In that case, you can use any of the following alternative notations to avoid parse errors.
    execute[...]
    execute'...'
    execute"..."
    execute:...
    This is the special form that frees you from parse errors as it does not expect the closing character. The catch is that it should be the last one in the comma-separated list of key-action pairs.
sk switches to the alternate screen when executing a command. However, if the command is expected to complete quickly, and you are not interested in its output, you might want to use execute-silent instead, which silently executes the command without the switching. Note that sk will not be responsive until the command is complete. For asynchronous execution, start your command as a background process (i.e. appending &). With if-query-empty and if-query-not-empty action, you could specify the action to execute depends on the query condition. For example
    sk --bind 'ctrl-d:if-query-empty(abort)+delete-char' If the query is empty, skim will execute abort action, otherwise execute delete-char action. It is equal to `delete-char/eof`.

AUTHOR
Jinzhou Zhang (lotabout@gmail.com)

SEE ALSO
Project homepage:
    https://github.com/lotabout/skim
Extra Vim plugin:
    https://github.com/lotabout/skim.vim

LICENSE
MIT